#ifndef CEOBROJ_H_
#define CEOBROJ_H_

#include <iostream>
#include <math.h>
#include <vector>

using namespace std;

class CeoBroj {
public:

	CeoBroj();

	CeoBroj( int n, unsigned osnova );

	CeoBroj operator+ ( const CeoBroj& c ) const ;

	CeoBroj operator- ( const CeoBroj& c ) const;

	CeoBroj operator* ( const CeoBroj& c ) const;

	CeoBroj operator/ ( const CeoBroj& c ) const;

	bool operator== (const CeoBroj& c)  const;

	bool operator!= (const CeoBroj& c)  const;

	unsigned Osnova() const;

	int Znak () const ;

	friend ostream& operator<< (ostream&, const CeoBroj&);

private:

	void InicijalizacijaCifara( unsigned n );

	char ZapisCifre( int c ) const;

	void AbsSabiranje( const CeoBroj& veci, const CeoBroj& manji, CeoBroj& r ) const;

	void AbsOduzimanje( const CeoBroj& veci, const CeoBroj& manji, CeoBroj& r ) const;
		// da li je prvi >= drugi
	bool AbsVeci( const CeoBroj& x, const CeoBroj& y ) const;

	static void AbsMnozenjeCifrom( const CeoBroj& x, unsigned cifra, CeoBroj& r )
	{
		unsigned prenos = 0;

		for( unsigned j=0; j<x._Cifre.size(); j++ )
		{
			unsigned a = x._Cifre[j] * cifra + prenos;
			r._Cifre.push_back( a % x._Osnova );
			prenos = a / x._Osnova;
		}

		if(prenos>0)
			r._Cifre.push_back( prenos );
	}

	unsigned			_Osnova;
	int 				_Znak;
	vector<unsigned> 	_Cifre;
};

#endif /* CEOBROJ_H_ */
