#include <cppunit/CompilerOutputter.h>
#include <cppunit/extensions/TestFactoryRegistry.h>
#include <cppunit/TestResult.h>
#include <cppunit/TestResultCollector.h>
#include <cppunit/TestRunner.h>
#include <cppunit/BriefTestProgressListener.h>

int main (int argc, char* argv[])
{
	// inicijalizacija objekta koji sadrzi informacije o testovima
	CPPUNIT_NS :: TestResult testresult;

	// osluskuje se objekat koji sakuplja rezultate izvrsenih testova
        CPPUNIT_NS :: TestResultCollector collectedresults;
        testresult.addListener(&collectedresults);

	// registrovanje slusaoca koji ispisuje rezultat za svaki test
        CPPUNIT_NS :: BriefTestProgressListener progress;
        testresult.addListener (&progress);

	//dodaju se registrovani testovi iz registra
	CPPUNIT_NS :: TestRunner testrunner;
	testrunner.addTest (CPPUNIT_NS :: TestFactoryRegistry :: getRegistry ().makeTest ());
	testrunner.run (testresult);

	// definise se da se rezultat testova ispisuje na izlaz za gresku
	CPPUNIT_NS :: CompilerOutputter compileroutputter (&collectedresults, std::cerr);
	compileroutputter.write ();

	// vraca 0 ako su testovi uspesno izvrseni
	return collectedresults.wasSuccessful () ? 0 : 1;
}
