#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QTime>
#include <QMutex>
#include <QFile>
#include <QTextStream>

//inicijalizacija statickih vrednosti
QMutex MainWindow::brojKugliMutex;
int MainWindow::brojKugli=0;

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::dodajKugle()
{

   MainWindow::brojKugli=qrand()%25;// generise se broj kugli vatrometa

    for(int i=0; i<brojKugli; i++)
    {
        Kugla* nit=new Kugla(i);
        connect(nit, SIGNAL(eksplodirala(int,int,bool,QString)), this, SLOT(dopisiKuglu(int, int, bool, QString)));
        connect(nit, SIGNAL(finished()), nit, SLOT(deleteLater()));
        nit->start();
    }

    ui->generisiPushButton->setEnabled(false);  //onemogucava se koriscenje dugmeta za generisaje kugli


}

//slot koji se poziva kada eksplodira kugla, dopisuju se podaci o eksplodiraloj
//kugli u textBrowser
void MainWindow::dopisiKuglu(int id, int vreme, bool otkazala, QString boja)
{
    if(boja.compare("Zuta")==0)
        tekst+="<font color='#ff0'>";
    else if(boja.compare("Crvena")==0)
        tekst+="<font color='#f00'>";
    else
        tekst+="<font color='#00f'>";

    tekst+=QString("Id kugle:%0 Vreme:%1 Otkazala:%2 Boja:%3\n").arg(id).arg(vreme).arg(otkazala).arg(boja);
    tekst+="</font><br/>";
    ui->textBrowser->setHtml(tekst);
}

void MainWindow::generisiHtml()
{
    //ako nisu sve kugle eksplodirale izdaje se poruka o tome, inace se upisuju podaci o kuglama iz textBrowser-a u html datoteku
  MainWindow::brojKugliMutex.lock();
    if(MainWindow::brojKugli>0)
        QMessageBox::information(this, "Broj kugli", QString("Broj kugli koje nisu eksplodirale je %0").arg(MainWindow::brojKugli), QMessageBox::Ok );
    else
    {
        QFile f("vatromet.html");
        QTextStream ts(&f);

        if(f.open(QIODevice::WriteOnly))
        {
            ts << ui->textBrowser->toHtml();
            f.close();
        }
        else
            QMessageBox::warning(this, QString("Otvaranje datoteke"), QString("Datoteka ne moze da se otvori"), QMessageBox::Ok);

    }

    MainWindow::brojKugliMutex.unlock();

}

