#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QMessageBox>
#include "kugla.h"
#include <QMutex>

namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow {
    Q_OBJECT
public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();
    static QMutex brojKugliMutex;
    static int brojKugli;  //broj kugli koje su generisane

private:
    Ui::MainWindow *ui;
    QString tekst;  //tekst koji ce se upisivati u textBrowse

private slots:
    void dopisiKuglu(int id, int vreme, bool otkazala, QString boja);  //slot koji se izvrsava kada se emituje signal da je kugla eksplodirala
    void dodajKugle();  //slot koji se izvrsava kada se klikne na dugme "Generisi kugle"
    void generisiHtml();//slot koji se izvrsava kada se klikne na dugme "Sacuvaj"
};

#endif // MAINWINDOW_H
